"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.FileResponseController = void 0;
var path_1 = __importDefault(require("path"));
var Logger_1 = require("../util/Logger");
var FileResponseController = /** @class */ (function () {
    function FileResponseController(fileRepository, profileService) {
        this.logger = Logger_1.GlobalLogger.getInstance();
        this.fileRepository = fileRepository;
        this.profileService = profileService;
    }
    FileResponseController.prototype.handleRequest = function (req, res) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var profileBaseDir, requestUri, method, possibleResponseFilePaths, _c, _d, chosenResponseFileLocation, extractedStatus, responseBody, e_1;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _e.trys.push([0, 4, , 5]);
                        profileBaseDir = this.profileService.getCurProfileBaseDir();
                        requestUri = req.path;
                        method = req.method;
                        _c = [[]];
                        return [4 /*yield*/, this._getPossibleFilePathsByFile(path_1["default"].join(profileBaseDir, requestUri), method, path_1["default"].normalize(profileBaseDir))];
                    case 1:
                        _d = [__spreadArray.apply(void 0, _c.concat([_e.sent(), true]))];
                        return [4 /*yield*/, this._getPossibleFilePathsByDirectory(path_1["default"].join(profileBaseDir, requestUri), method)];
                    case 2:
                        possibleResponseFilePaths = __spreadArray.apply(void 0, _d.concat([_e.sent(), true]));
                        chosenResponseFileLocation = this._assertExistsAndSelectSingleFilePath(possibleResponseFilePaths, path_1["default"].join(profileBaseDir, requestUri), method);
                        extractedStatus = this._extractStatusFromFilePath(chosenResponseFileLocation);
                        this.logger.trace('Response file: ' + chosenResponseFileLocation);
                        return [4 /*yield*/, this.fileRepository.readFileContents(chosenResponseFileLocation)];
                    case 3:
                        responseBody = _e.sent();
                        res.status(extractedStatus).send(responseBody);
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _e.sent();
                        this.logger.error(e_1);
                        if (((_a = e_1 === null || e_1 === void 0 ? void 0 : e_1.message) !== null && _a !== void 0 ? _a : '').includes('no such file or directory')
                            || ((_b = e_1 === null || e_1 === void 0 ? void 0 : e_1.message) !== null && _b !== void 0 ? _b : '').includes('No possible responses found in directory')) {
                            res.status(404).send({
                                message: e_1.message
                            });
                        }
                        else {
                            res.status(500).send({
                                message: e_1.message
                            });
                        }
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    FileResponseController.prototype._getPossibleFilePathsByFile = function (directoryPath, method, dirToExclude) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var oneDirectoryUp, lastUriPartToUseAsFile, allFilesInOneUpDirectory, fileNamesWithLastUriPart, filteredFilesWithDirectory;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (directoryPath.split(/[\\|/]+$/).join('') == dirToExclude.split(/[\\|/]+$/).join('')) {
                            return [2 /*return*/, []];
                        }
                        oneDirectoryUp = path_1["default"].normalize(path_1["default"].join(directoryPath, '..'));
                        lastUriPartToUseAsFile = directoryPath.replace(oneDirectoryUp, "");
                        return [4 /*yield*/, this.fileRepository.getAllFilenamesInDirIfDirExists(oneDirectoryUp)];
                    case 1:
                        allFilesInOneUpDirectory = (_a = _b.sent()) !== null && _a !== void 0 ? _a : [];
                        fileNamesWithLastUriPart = allFilesInOneUpDirectory.filter(function (singleFileName) {
                            return path_1["default"].join('/', singleFileName).includes(lastUriPartToUseAsFile);
                        });
                        filteredFilesWithDirectory = fileNamesWithLastUriPart.map(function (singleFileName) {
                            return path_1["default"].join(oneDirectoryUp, singleFileName);
                        });
                        return [2 /*return*/, filteredFilesWithDirectory];
                }
            });
        });
    };
    FileResponseController.prototype._getPossibleFilePathsByDirectory = function (directoryPath, method) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var allFilesInDirectory, fileNamesWithMethod, filteredFilesWithDirectory;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.fileRepository.getAllFilenamesInDirIfDirExists(directoryPath)];
                    case 1:
                        allFilesInDirectory = (_a = _b.sent()) !== null && _a !== void 0 ? _a : [];
                        fileNamesWithMethod = allFilesInDirectory.filter(function (singleFileName) {
                            return singleFileName.startsWith(method);
                        });
                        filteredFilesWithDirectory = fileNamesWithMethod.map(function (singleFileName) {
                            return path_1["default"].join(directoryPath, singleFileName);
                        });
                        return [2 /*return*/, filteredFilesWithDirectory];
                }
            });
        });
    };
    FileResponseController.prototype._assertExistsAndSelectSingleFilePath = function (possibleResponseFilePaths, directoryPath, method) {
        if (possibleResponseFilePaths.length === 0) {
            throw new Error('No possible responses found in directory: "' + directoryPath + '" for method: ' + method);
        }
        else if (possibleResponseFilePaths.length > 1) {
            this.logger.warn('Multiple possible response files. Defaulting to first one: \n  '
                + JSON.stringify(possibleResponseFilePaths[0], null, 2)
                + '\nAll possibilities: '
                + JSON.stringify(possibleResponseFilePaths, null, 2));
        }
        return possibleResponseFilePaths[0];
    };
    FileResponseController.prototype._extractStatusFromFilePath = function (fileLocation) {
        var _a;
        var httpCodeMatches = fileLocation.match(/\d\d\d/);
        if (httpCodeMatches === null) {
            return 200;
        }
        else {
            return parseInt((_a = httpCodeMatches[0]) !== null && _a !== void 0 ? _a : '200');
        }
    };
    return FileResponseController;
}());
exports.FileResponseController = FileResponseController;
