export declare abstract class FilteredLogger {
    logLevel: LogLevel;
    abstract logFn(message?: any, ...optionalParams: any[]): void;
    abstract errorFn(message?: any, ...optionalParams: any[]): void;
    trace(message?: any, ...optionalParams: any[]): void;
    debug(message?: any, ...optionalParams: any[]): void;
    info(message?: any, ...optionalParams: any[]): void;
    warn(message?: any, ...optionalParams: any[]): void;
    error(message?: any, ...optionalParams: any[]): void;
    fatal(message?: any, ...optionalParams: any[]): void;
}
export declare enum LogLevel {
    ALL = "ALL",
    TRACE = "TRACE",
    DEBUG = "DEBUG",
    INFO = "INFO",
    WARN = "WARN",
    ERROR = "ERROR",
    FATAL = "FATAL",
    OFF = "OFF"
}
export declare class ConsoleFilteredLogger extends FilteredLogger {
    logFn(message?: any, ...optionalParams: any[]): void;
    errorFn(message?: any, ...optionalParams: any[]): void;
}
export declare class GlobalLogger {
    private static instance;
    private constructor();
    static getInstance(): FilteredLogger;
}
