"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.GlobalLogger = exports.ConsoleFilteredLogger = exports.LogLevel = exports.FilteredLogger = void 0;
var FilteredLogger = /** @class */ (function () {
    function FilteredLogger() {
    }
    FilteredLogger.prototype.trace = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if ([
            LogLevel.ALL,
            LogLevel.TRACE
        ].includes(this.logLevel)) {
            this.logFn.apply(this, __spreadArray([message], optionalParams, false));
        }
    };
    FilteredLogger.prototype.debug = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if ([
            LogLevel.ALL,
            LogLevel.TRACE,
            LogLevel.DEBUG
        ].includes(this.logLevel)) {
            this.logFn.apply(this, __spreadArray([message], optionalParams, false));
        }
    };
    FilteredLogger.prototype.info = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if ([
            LogLevel.ALL,
            LogLevel.TRACE,
            LogLevel.DEBUG,
            LogLevel.INFO
        ].includes(this.logLevel)) {
            this.logFn.apply(this, __spreadArray([message], optionalParams, false));
        }
    };
    FilteredLogger.prototype.warn = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if ([
            LogLevel.ALL,
            LogLevel.TRACE,
            LogLevel.DEBUG,
            LogLevel.INFO,
            LogLevel.WARN
        ].includes(this.logLevel)) {
            this.logFn.apply(this, __spreadArray([message], optionalParams, false));
        }
    };
    FilteredLogger.prototype.error = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if ([
            LogLevel.ALL,
            LogLevel.TRACE,
            LogLevel.DEBUG,
            LogLevel.INFO,
            LogLevel.WARN,
            LogLevel.ERROR
        ].includes(this.logLevel)) {
            this.errorFn.apply(this, __spreadArray([message], optionalParams, false));
        }
    };
    FilteredLogger.prototype.fatal = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        if ([
            LogLevel.ALL,
            LogLevel.TRACE,
            LogLevel.DEBUG,
            LogLevel.INFO,
            LogLevel.WARN,
            LogLevel.ERROR,
            LogLevel.FATAL
        ].includes(this.logLevel)) {
            this.errorFn.apply(this, __spreadArray([message], optionalParams, false));
        }
    };
    return FilteredLogger;
}());
exports.FilteredLogger = FilteredLogger;
var LogLevel;
(function (LogLevel) {
    LogLevel["ALL"] = "ALL";
    LogLevel["TRACE"] = "TRACE";
    LogLevel["DEBUG"] = "DEBUG";
    LogLevel["INFO"] = "INFO";
    LogLevel["WARN"] = "WARN";
    LogLevel["ERROR"] = "ERROR";
    LogLevel["FATAL"] = "FATAL";
    LogLevel["OFF"] = "OFF";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
var ConsoleFilteredLogger = /** @class */ (function (_super) {
    __extends(ConsoleFilteredLogger, _super);
    function ConsoleFilteredLogger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ConsoleFilteredLogger.prototype.logFn = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        console.log.apply(console, __spreadArray([message], optionalParams, false));
    };
    ConsoleFilteredLogger.prototype.errorFn = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        console.error.apply(console, __spreadArray([message], optionalParams, false));
    };
    return ConsoleFilteredLogger;
}(FilteredLogger));
exports.ConsoleFilteredLogger = ConsoleFilteredLogger;
var GlobalLogger = /** @class */ (function () {
    function GlobalLogger() {
    }
    GlobalLogger.getInstance = function () {
        if (this.instance === undefined) {
            this.instance = new ConsoleFilteredLogger();
        }
        return this.instance;
    };
    return GlobalLogger;
}());
exports.GlobalLogger = GlobalLogger;
